package com.jscape.inet.terminal.commands;

import com.jscape.inet.terminal.Terminal;

/**
 * DECTST -- Invoke Confidence Test.
 * By default does nothing.
 */
public class DECTSTCommand
        implements ControlCommand {

    public static final String CANONICAL_FORM = "\033[y";
    private static final DECTSTCommand INSTANCE = new DECTSTCommand();

    //----------------------------------------------------------------------------

    /**
     * Returns one and only one instance of this type.
     *
     * @return one and only one instance of this type.
     */
    public static DECTSTCommand getInstance() {
        return INSTANCE;
    }

    //----------------------------------------------------------------------------

    /**
     * Private constructor to prevent uncontrolled creation.
     */
    private DECTSTCommand() {
    }

    //----------------------------------------------------------------------------

    /**
     * Executes command giving parameters and <code>Terminal</code> object.
     *
     * @param params   array of <code>int</code> command parametrs.
     * @param terminal target <code>Terminal</code> object.
     */
    public void execute(int[] params, Terminal terminal) {
    }

    //----------------------------------------------------------------------------

    /**
     * Sends command to remote host.
     *
     * @param params   command parameters.
     * @param terminal target <code>Terminal</code> object to send command.
     */
    public void send(int[] params, Terminal terminal) {
        if (params == null || params.length == 0) {
            terminal.send("\033[2;0y");
        } else {
            StringBuffer b = new StringBuffer("\033[2;");

            for (int i = 0; i < params.length; ++i) {
                b.append(params[i]);
                if (i < (params.length - 1)) {
                    b.append(';');
                }
            }

            b.append('y');
            terminal.send(b.toString());
        }
    }
}
